/**

 lista Events
 100- konstruktor CMMS_CurrentEv_View_constructor - odczyt danych

 110- konstruktor CMMS menu cmms filtr menu - zmiana filtrów wydzialu / indeksu
 */
'use strict';
lang[80]='Awaria';
lang[81]='Eksploatacja';
lang[82]='Ostrzeżenie';
lang[83]='Zgłoszenie awarii';
lang[84]='Usterka';
lang[85]='Modernizacja';
lang[86]='Zgłoszenie eksploatacji';
lang[87]='';
lang[88]='';
lang[89]='';
lang[90]='Zgłoszona';
lang[91]='Oczekiwanie na dostęp';
lang[92]='Diagnostyka / Naprawa';
lang[93]='Czasowo zawieszone';
lang[94]='Oczekiwanie na części';
lang[95]='Oczekiwanie na serwis';
lang[96]='Oczekiwanie na testy';
lang[97]='Testy ';
lang[98]='Zakończona';
lang[99]='Przygotowanie';
lang[100]='W realizacji';
lang[101]='Zakończono';
lang[102]='';
lang[103]='';
lang[104]='Niski priorytet';
lang[105]='Średni priorytet';
lang[106]='Wysoki priorytet';
lang[107]='Nie wiem';
lang[108]='Mechanik';
lang[109]='Elektryk';
lang[110]='Automatyk';
lang[111]='';

function evmode_str(nr){ return lang[nr+80] }

var ev_ico_code=[ '\uf633', '\uf2b9','\uf250', '\uf189', '\uf519','\uf5b0'];
var ev_ico=['mdi-wrench','mdi-elevator', 'mdi-comment-alert-outline','mdi-bell-ring-outline','mdi-security','mdi-tooltip-outline-plus'];
var ev_colors=['#FFC1E3','#B0E2F2','#FFFBA6','red','#FFC1E3','#DDF398'];
var ev_nr_convert=[3,0,4,1,5,2,0,7,8,9,10];


function ev_state_name( state,mode,ex  ){
    var s=lang[90];
    if (mode==3){
        if (ex==1){s=lang[83]}
        if (ex==2){s=lang[86]}
    }
    if (mode==0 || mode==4 ){
        s=lang[ state+90 ]
    }
    if (mode==1 || mode==5){
        if (state==0){s=lang[90]}
        if (state==1){s=lang[99]}
        if (state==2){s=lang[100]}
        if (state==3){s=lang[101]}
    }
    return s;

}
function ev_state_name_au(state){ return ev_state_name(state,0,0)  }
function ev_state_name_em(state){ return ev_state_name(state,1,0)  }

function evmode_color(mode,ex){
    var c=ev_colors[mode];
    if (mode==3 && ex==2 ){  c='#00A2E8'   }
    return c
}

function ev_ico_color(mode,ex){
    var cl='red';
    if (mode==3 && ex==2){cl='#00A2E8' }
    else{
        if (mode==1 || mode==5){cl='#00A2E8' }

    }
    return cl;
}

function evnrc(nr){ return ev_nr_convert[nr]   }


var cmms_edit_ob_ref='';  // referencja na obiekt edycji


var cmms_set={   // wartości ustawione
    theme:0,
    lang_change:false,
    pin:true,
    logout:30,
    logout2:5,
    refresh_time:4,
    stop_after:true,
    audio_alarm:false,
    aaa:333
};

var cmms_set_pset={ // wartosci domyślne - mozna modyfikowac przed inicjacja frameworku
    theme:'S',
    lang_change:false,
    pin:'S',
    refresh_time:'S',
    stop_after:'S',
    logout:30,
    logout2:5,
    audio_alarm:false,
    aaa:333
};

var cmms_set_pset_df={  // wartosci domyslne ( dla brakujacych kluczy )
    theme:0,
    lang_change:false,
    pin:true,
    logout:30,
    logout2:5,
    refresh_time:4,
    stop_after:true,
    audio_alarm:false,
    aaa:333
};

NApp_constructor.prototype.cmms_set=cmms_set;
NApp_constructor.prototype.cmms_set_pset=cmms_set_pset;
NApp_constructor.prototype.cmms_set_pset_df=cmms_set_pset_df;
NApp_constructor.prototype.refresh_mode=0;
NApp_constructor.prototype.id_wydzial=0;
NApp_constructor.prototype.id_index=0;
NApp_constructor.prototype.perm_za=function(){ return  nApp.auth.get_perm(2)     };
NApp_constructor.prototype.perm_ev_edit=function(){ return  nApp.auth.get_perm(3)     };

NApp_constructor.prototype.cmms_framework_init=function( callback_app_scope){
    var that=this;
    // fwcmms info
    this.cfgi.footer_info='CMMS Maszyna SMART  neuron.com.pl';
    this.cfgi.lib_base_id=17;
    this.cfgi.lib_base_name='CMMS Maszyna SMART';
    this.cfgi.help_url='http://www.neuron.com.pl/cmms-help/r0.html';
    // zaladuj ustawienia lokalne

    function _lps(propName ){
        var s=propName;
        if (that.cmms_set_pset[propName]=='S'){ that.cmms_set[ s ] = nApp.cfgi.fromLS('s_'+s, that.cmms_set_pset_df[ s ] );  }
        else { that.cmms_set[ s ] =that.cmms_set_pset[propName]  }
    }

    _lps('theme');
    _lps('pin');
    _lps('refresh_time');
    _lps('stop_after');
    _lps('logout');
    _lps('logout2');
    _lps('audio_alarm');

    nApp.auth.use_pin = that.cmms_set.pin;
    nApp.auth.log_time = that.cmms_set.logout;
    nApp.auth.log_time2 = that.cmms_set.logout2 * 60 ;
    nApp.cfgi.rf_timer_speed =that.cmms_set.refresh_time*10;

    nApp.AjaxHandle();


    // zaladuj dane i opcjonalnie lang z servwra
    this.cfgi.cfg_info_from_server( function(){

        nApp.cfgi.setStyle( nApp.cmms_set.theme  );

        is_callback(callback_app_scope);
        nApp.cfgi.create_info_box();
        BindClick('#MasterSetup', function(){ cmms_set_form()});

        $('#status_bar_infoc').attr('src','../_fw/i_cg.png' );
        nApp.auth.make_user_panel();
        nApp.auth.init();
        nApp.timerstart( );
    });

};


function cmms_set_form(){
    var m= new Kit_dialog_constructor(333,400,2,1,true,true);
    m.onTop=true;
    m.btn_call_ok=function(){

        ft.getval();
        console.log( ft.c_value_i  +'  '+ ft.c_value_b  );
        if (nApp.cmms_set_pset.theme=='S'){ nApp.cfgi.toLS('s_theme', ft.c_value_i[1] )}

        if (nApp.cmms_set_pset.pin =='S')    { nApp.cfgi.toLS('s_pin', ft.c_value_b[2] )}
        if (nApp.cmms_set_pset.refresh_time =='S')  { nApp.cfgi.toLS('s_refresh_time', ft.c_value_i[3] )}
        if (nApp.cmms_set_pset.stop_after =='S')    { nApp.cfgi.toLS('s_stop_after', ft.c_value_b[4] )}
        if (nApp.cmms_set_pset.logout =='S')       { nApp.cfgi.toLS('s_logout', ft.c_value_i[10] )}
        if (nApp.cmms_set_pset.logout2 =='S')      { nApp.cfgi.toLS('s_logout2', ft.c_value_i[11] )}
        if (nApp.cmms_set_pset.audio_alarm =='S')    { nApp.cfgi.toLS('s_audio_alarm', ft.c_value_b[5] )}
        location.reload()
    };
    m.btn_call_close=function(){   };
    m.draw();
    m.addHeader('Ustawienia');

    var ft=new Kit_form_constructor('tf');
    if (nApp.cmms_set_pset.theme=='S'){  ft.addCombo( 1,lang[41] ,[42,43,44], nApp.cmms_set.theme) }
    if (nApp.cmms_set_pset.pin=='S')    {ft.addCheck(2,'Logowanie PINem',nApp.cmms_set.pin)}
    if (nApp.cmms_set_pset.refresh_time =='S') {ft.addSpin(3,'czas odświeżnia [x10sec.]', nApp.cmms_set.refresh_time ,1,300)}
    if (nApp.cmms_set_pset.stop_after=='S'){ft.addCheck(4,'zatrzymaj po 5 błędach',nApp.cmms_set.stop_after )}
    if (nApp.cmms_set_pset.logout =='S')       {ft.addSpin(10,lang[22], nApp.cmms_set.logout ,10,1000)}
    if (nApp.cmms_set_pset.logout2 =='S')      {ft.addSpin(11,lang[23], nApp.cmms_set.logout2 ,1,1000)}
    if (nApp.cmms_set_pset.audio_alarm=='S'){ft.addCheck(5,'Audio Alarm',nApp.cmms_set.audio_alarm )}

    var s='<div style="position: relative" >'+ft.htmlString()+'<br>po zatwierdzeniu aplikacja zostanie przeładowana</div>';
    m.content( s ,false );
    ft.activate();
    m.showDialog(0);

}


///////////////

function w_i_change(that){

    function _dsp(r){
        $('#csf_fe_dw').html( that.wydzial_name );
        $('#csf_fe_di').html( that.index_name );
        nApp.id_wydzial=that.wydzial_id;
        nApp.id_index=that.index_id;
        nApp.goEvent(110,0);
        nApp.goEvent(100,0);
        if (r){
            that.display();
            nApp.cfgi.toLS('wydzial_n', that.wydzial_name );
            nApp.cfgi.toLS('wydzial_id', that.wydzial_id );
            nApp.cfgi.toLS('index_n', that.index_name );
            nApp.cfgi.toLS('index_id', that.index_id );
        }
    }

    var fb=new Kit_dialog_constructor(330,250,1,0,true,true);
    fb.draw();
    fb.addHeader('filtry bazowe');
    var sx='';
    sx+='<table class="w3-table w3-bordered" style="font-size:12px" >';
    sx+='<tr><td width="250"><b>wydział</b><br><div id="csf_fe_dw">abcd</div></td><td><button id="csf_ed_bw" class="btn btn-blue">set</button></td><td><button id="csf_ed_bwr" class="btn btn-red">X</button></td></tr>';
    sx+='<tr><td width="250"><b>index  </b><br><div id="csf_fe_di">abcd</div></td><td><button id="csf_ed_bi" class="btn btn-blue">set</button></td><td><button id="csf_ed_bir" class="btn btn-red">X</button></td></tr>';
    sx+='</table>';

    fb.content(sx);
    fb.showDialog();
    _dsp(false);

    BindClick('#csf_ed_bw',function(){
        nfw_get_dict(5,1,'wydział', function(nm,id){
            that.wydzial_name=nm;
            that.wydzial_id=id;
            _dsp(true);
        } )
    });
    BindClick('#csf_ed_bwr',function(){
        that.wydzial_name='';
        that.wydzial_id=0;
        _dsp(true);
    });
    BindClick('#csf_ed_bi',function(){
        nfw_get_dict(8,0,'Index', function(nm,id){
            that.index_name=nm;
            that.index_id=id;
            _dsp(true);
        } )
    });
    BindClick('#csf_ed_bir',function(){
        that.index_name='';
        that.index_id=0;
        _dsp(true);
    });

}


function CMMS_filtr_menu_constructor(parent){
    var that=this;
    this.go_menu='';
    this.box='';
    this.wydzial_name=nApp.cfgi.fromLS('wydzial_n','');
    this.wydzial_id=  nApp.cfgi.fromLS('wydzial_id',0);
    this.index_name=  nApp.cfgi.fromLS('index_n','');
    this.index_id=    nApp.cfgi.fromLS('index_id',0);
    this.seccount=0;
    this.rfnow= Date.now();

    this.display=function(){
        $('#csf_w').html(   that.wydzial_name);
        $('#csf_i').html(   that.index_name );
    };

    this.draw=function(){
        nApp.id_wydzial=this.wydzial_id;
        nApp.id_index=this.index_id;
        var s='';
        s+='<div class="w4-bar" style="max-height: 30px; background-color: #353535">';
        s+='<div class="w4-bar-item" >   <button id="csf_brf" class="btn btn-black "><i class="mdi i20 mdi-sync"></i></button><button id="csf_bf" class="btn btn-black "><i class="mdi i20 mdi-filter-outline"></i></button></div>';
        s+='<div class="w4-bar-item cmmenu-fd" >  <table style="padding-top: 5px ;font-size: 15px "><tr style="vertical-align: top; "><td width="80"  >wydział</td><td width="390" id="csf_w">w</td><td width="80">Index</td><td id="csf_i">i </td></tr></table></div>';

        $(parent).html(s);
        this.display();

        BindClick('#csf_brf',function(){  nApp.core_rtimer_reset()  });
        BindClick('#csf_bf',function(){     w_i_change(that)     });
    }
}

function CMMS_za_menu_constructor(parent) {
    var that = this;
    this.go_menu = function(){};
    this.box = '';
    this.wydzial_name = nApp.cfgi.fromLS('wydzial_n', '');
    this.wydzial_id = nApp.cfgi.fromLS('wydzial_id', 0);
    this.index_name = nApp.cfgi.fromLS('index_n', '');
    this.index_id = nApp.cfgi.fromLS('index_id', 0);

    this.display=function(){
        $('#csf_w').html(  elipsis( that.wydzial_name,28) );
        $('#csf_i').html(  elipsis( that.index_name,26) );
        that._refresh()
    };
    this._refresh=function(){
        nApp.goEvent(100,0);
    };
    this.draw=function() {
        nApp.id_wydzial = this.wydzial_id;
        nApp.id_index = this.index_id;

        nApp.view.tb_addContainer(200,'nfw-user-container' );
        nApp.view.tb_addSeparator(10);
        nApp.view.tb_addContainer(300,'filtr-container' );
        var s='';//  '<button id="csf_bf" class="btn btn-black " style="min-height: 50px;width: 50px"><i class="mdi i20 mdi-filter-outline"></i></button>';
        s+=' <div class="w4-bar" style="min-height: 50px; background-color: #353535">';
        s+='<div class="w4-bar-item" >    <button id="csf_bf" class="btn btn-orange " style="min-height: 50px"><i class="mdi i24 mdi-filter-outline"></i></button></div>';
        s+='<div class="w4-bar-item cmmenu-fd" >  <table style="max-width:260px; "><tr style="vertical-align: top; "><td width="60"  >wydział</td><td id="csf_w">w</td></tr> <tr ><td>Index</td><td id="csf_i">i </td></tr></table></div>';
        s+='</div>  ';
        $('#filtr-container').html(s);
        this.display();

        nApp.view.tb_addBtn(true,'btn-blue','mdi-bell-ring-outline','Zgłoś eksploatację','call', function(){ is_callback( that.go_menu(2) ); }  );
        nApp.view.tb_addBtn(true,'btn-red','mdi-bell-ring-outline','Zgłoś awarię&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;','call', function(){ is_callback( that.go_menu(1) ); }  );
        nApp.view.tb_addBtn(false,'btn-green','i20 mdi-calendar-check','30 dni','call', function(){ is_callback(   that.go_menu(3)); }  );

        BindClick('#csf_bf',function(){     w_i_change(that)     });

        nApp.goEvent(100,0);
    }


}

function CMMS_phone_menu_constructor(parent){
    var that=this;
    this.go_menu='';
    this.box='';
    this.wydzial_name=nApp.cfgi.fromLS('wydzial_n','');
    this.wydzial_id=  nApp.cfgi.fromLS('wydzial_id',0);
    this.index_name=  nApp.cfgi.fromLS('index_n','');
    this.index_id=    nApp.cfgi.fromLS('index_id',0);
    this.seccount=0;
    this.rfnow= Date.now();

    this.display=function(){
        $('#csf_w').html(  elipsis( that.wydzial_name,28) );
        $('#csf_i').html(  elipsis( that.index_name,26) );
        that._refresh()
    };


    this._refresh=function(){
             // is_callback( that.go_refresh );
                nApp.goEvent(100,0);

              that.rfnow=Date.now();
              that.seccount=0;
    };

    this.draw=function(){
        nApp.id_wydzial=this.wydzial_id;
        nApp.id_index=this.index_id;
        var s='';
        s+='<div class="w4-bar" style="min-height: 40px; background-color: #353535">';
        s+='<div class="w4-bar-item " ><button  id="nfw-user-btn" class="btn btn-red rbround" ><i class="mdi i24 mdi-lock-outline"></i></button></div>';
        s+='<div class="w4-bar-item "><div id="nfw-user-display" class="cmmenu-userd">władysław pasikonik</div>  </div>';
        s+='<div id="nfw-user-timer" class="cmmenu-utd  nfwusertc   " style=" top:23px; left:150px;    ">665000s.</div>';
        s+='<div class="w4-bar-item w3-right" ><button id="csf_refresh" class="btn btn-blue " style="min-width: 60px;" ><i class="mdi i24 mdi-refresh"></i></button></div>';
        s+='<div class="w4-bar-item w3-right"><button id="csf_menu" class="btn btn-green lbround" style="min-width: 60px; " ><i class="mdi i24 mdi-menu"></i></button> </div>';
        s+='<div id="csf_rt" class="cmmenu-rfd  rtc123" style=" top:48px; right:6px;    ">0-00-12</div>';
        s+='<div class="cmmenu-arrow-up-b rtc123" style="right: 10px; top: 40px"></div>';
        s+='</div>';
        s+='<div class="cmmenu-sep" ></div> <div class="w4-bar" style="min-height: 40px; background-color: #353535">';
        s+='<div class="w4-bar-item" >    <button id="csf_bf" class="btn btn-orange rbround"><i class="mdi i24 mdi-filter-outline"></i></button></div>';
        s+='<div class="w4-bar-item cmmenu-fd" >  <table style="max-width:260px; "><tr style="vertical-align: top; "><td width="60"  >wydział</td><td id="csf_w">w</td></tr> <tr ><td>Index</td><td id="csf_i">i </td></tr></table></div>';
        s+='</div>   <div class="cmmenu-sep" ></div>';


        $(parent).html(s);
        this.display();
        $('.rtc123').hide();

        BindClick('#csf_refresh',function(){ that._refresh() }  );
        BindClick('#csf_menu',function(){ is_callback( that.go_menu ); }  );
        BindClick('#csf_bf',function(){     w_i_change(that)     });

        nApp.BindEvent(function(ev,a2,a3){
            if (a2==1 )  {
                that.seccount = (   Date.now()-that.rfnow )/1000;
                $('#csf_rt').text(   ktime.SecToGMS(  that.seccount.toFixed(0) ) );
                $('.rtc123').toggle( that.seccount > 30   )
            }
            if (a2==100){ that.seccount=0; that.rfnow=Date.now();  }
        });


    }
}


